/*
Fundamentos da Computação II
Primeiro semestre de 2009
Projeto final - Jogo
Hugo Chinaglia dos Santos nºUSP:6451151

Pegue as maças!
 */


PImage fundo; // declara imagem do fundo
PImage sesta; // declara imagem da cesta
PImage maca; // declara imagem das maçãs
PImage reset; // declara imagem da seta circular que funciona como botão de reset/restart

PFont font; //declara uma font

int[] xm; // declara vetor da posição x da maca
int[] ym; // declara vetor da posição y da maca
int n; // número de maçãs

int xc=1; // declara posicao x da cesta, que se incia com valor 1
int vc=10; // declara e dá valor 10 para a velocidade da cesta
int [] vm; // declara vetor da velocidade das maçãs

int pontos = 0; // declara variável que faz contagem das maçãs que caíram na cesta, iniciando com valor zero.
int segundos; // declara variável que marcará o tempo de cada partida
int desconto = 0; // declara variável que vai descontar o tempo ja contado para que a marcação possa ser zerada a cada partida







void DesenhaMacas (){ // função que posiciona aleatoriamente N macas na área da árvore
  for(int i=0;i<n;i++){ 
    xm[i]=int(random(155,660)); //sorteia, dentro da área da copa da árvore, n posições para as posições no eixo x das maçãs
    ym[i]=int(random(60,210)); //sorteia, dentro da área da copa da árvore, n posições para as posições no eixo y das maçãs
  }
}


void caiMacas(){ // função que dá velocidade às maçãs que o mouse clicar sobre, fazendo-as cair.
  for(int i = 0; i<n ; i++){
    if(mousePressed && dist(mouseX, mouseY, xm[i]+10, ym[i]+10)<10){ //condição de mouse pressionado e distância entre o mouse e uma maçã
      vm[i] = 15;                                                    //que faz com que elas deixem de ter valor nulo de velocidade
    }
  }
}


void cesta (){ // função que faz o movimento de ida e volta da cesta
  image(fundo,0,0); //desenha imagem de fundo, apagando os rastros
  if((xc>0)&&(xc<708)){ //condição que só movimenta a cesta dentro da área da tela do jogo
    image(sesta,xc,400,102,60); //carrega imagem da sesta
    xc = xc + vc; // movimentação da cesta
  }
  else{ //condição que faz a cesta retornar quando alcança o fim da tela
    vc = -vc;
    xc = xc + vc;
  }
}

void encesta(){ // função que faz as maçãs serem encestadas caso elas passem pela posição onde se localiza a borda da cesta
  for(int i = 0 ; i<n ; i++){
    if((ym[i]>390) && (ym[i]<410) && (xm[i] > xc) && (xm[i] < xc+92)){ //se as maças cruzam a linha superior da cesta elas são encestadas

      vm[i]= 0; // a velocidade delas é anulada
      ym[i] = 610; // e são mandadas para fora do campo visual da tela

      pontos = pontos + 1; // acrescenta-se uma unidade a variável pontos
    }
  }
}


void reset(){ // função que gera uma nova partida e anula a anterior
  for(int i = 0 ; i<n ; i++){
    if((mousePressed) && (mouseX > 750) && (mouseX < 790) && (mouseY > 535) && (mouseY < 575)){ //condição que verifica se o mouse clicou sobre a imagem
      vm[i] = 0; //a velocidade das mçãs se anulam para que parem de cair
      pontos = 0; // a variável pontos é zerada
      DesenhaMacas(); // as maçãs são novamente sorteadas na copa da árvore
      desconto = millis()/1000; // a variável desconto assume o valro atual da contagem do tempo desde a abertura do jogo, zerando a variável segundos
      delay(2); //um pequeno atraso para não se reiniciar o jogo mais de uma vez num único click
    }
  }
}






void setup(){

  size(800,600); //define tamanho da janela
  noStroke();
  smooth();

  sesta = loadImage ("cesta.gif"); //carrega imagem da cesta
  fundo = loadImage ("fundo.jpg"); //carrega imagem do fundo
  maca = loadImage ("maca.gif"); //carrega imagem da maçã
  reset = loadImage ("reset.gif"); //carrega imagem da seta circular

  font = loadFont ("ArialRoundedMTBold-24.vlw"); //carrega a font Arial rounded
  textFont(font, 24); //Define corpo da font para 24 pixels

  n=20; //define que serão 20 maçãs
  xm = new int[n]; // vetor da posição x da maçã terá n valores
  ym = new int[n]; // vetor da posição y da maça terá n valores
  vm = new int [n]; // vetor da velocidade das maças terá n valores, que serão ou zero ou 15, dependendo se a maçã está caindo ou não

  for (int i = 0; i<n ; i++){ //comando que garante que ao se iniciar o jogo todas as maçãs fiquem paradas por terem velocidade nula.
    vm[i]=0;

  }
  DesenhaMacas(); //chama função que desenha as maças na árvore para se começar o jogo
}



void draw(){

  cesta(); //chama e atualiza a função que movimenta a cesta
  caiMacas(); //chama e atualiza a função que faz as maçãs cairem ao serem clicadas

    for(int i=0;i<n;i++){ //ccomando que redesenha as maçãs a cada quadro
    image(maca,xm[i],ym[i]);
  }

  for (int i = 0; i<n; i++){ //comando que movimenta as maças em queda até terem valor y maior que 550 pixels, fazendo com que parem no chão.
    if(ym[i]<550){
      ym[i] = ym[i] + vm[i];
    }
  }

  image(reset,750,535); // desenha imagem da seta circular

  encesta();  //chama e atualiza a função que faz as maças parecem cair no cesto
  reset();  //chama e atualiza a função que recomeça o jogo

  fill(0); //define a cor dos escritos como preta
  text("Maçãs:", 20, 550); //gera texto do escrito "Maçãs:"
  text(pontos, 110, 550); //gera texto que escreve o valor da variavel pontos

  segundos = millis()/1000 - desconto; // define valor da variável segundos, que conta o tempo em segundos desde que um novo jogo é começado
  //através da função millis que conta o tempo em milésimos e um desconto que é aplicado a cada vez
  // que o jogo recomeça
  text("Tempo:", 20, 580); //gera o escrito "Tempo:"
  text(segundos, 110, 580); // gera o texto com o valor da variável segundos

}





